Index: contrib/ntp/ntpd/ntp.keys.mdoc.in
===================================================================
--- contrib/ntp/ntpd/ntp.keys.mdoc.in	(版本 314126)
+++ contrib/ntp/ntpd/ntp.keys.mdoc.in	(版本 316722)
@@ -1,9 +1,9 @@
-.Dd November 21 2016
+.Dd March 21 2017
 .Dt NTP_KEYS 5 File Formats
 .Os SunOS 5.10
 .\"  EDIT THIS FILE WITH CAUTION  (ntp.mdoc)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:06 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:44:22 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp.keys.def
 .\"  and the template file   agmdoc-file.tpl
 .Sh NAME
@@ -155,7 +155,7 @@
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh "BUGS"
 Please send bug reports to: http://bugs.ntp.org, bugs@ntp.org
Index: contrib/ntp/ntpd/ntp_io.c
===================================================================
--- contrib/ntp/ntpd/ntp_io.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_io.c	(版本 316722)
@@ -516,13 +516,17 @@
 /*
  * function to dump the contents of the interface structure
  * for debugging use only.
+ * We face a dilemma here -- sockets are FDs under POSIX and
+ * actually HANDLES under Windows. So we use '%lld' as format
+ * and cast the value to 'long long'; this should not hurt
+ * with UNIX-like systems and does not truncate values on Win64.
  */
 void
 interface_dump(const endpt *itf)
 {
 	printf("Dumping interface: %p\n", itf);
-	printf("fd = %d\n", itf->fd);
-	printf("bfd = %d\n", itf->bfd);
+	printf("fd = %lld\n", (long long)itf->fd);
+	printf("bfd = %lld\n", (long long)itf->bfd);
 	printf("sin = %s,\n", stoa(&itf->sin));
 	sockaddr_dump(&itf->sin);
 	printf("bcast = %s,\n", stoa(&itf->bcast));
@@ -570,11 +574,11 @@
 static void
 print_interface(const endpt *iface, const char *pfx, const char *sfx)
 {
-	printf("%sinterface #%d: fd=%d, bfd=%d, name=%s, flags=0x%x, ifindex=%u, sin=%s",
+	printf("%sinterface #%d: fd=%lld, bfd=%lld, name=%s, flags=0x%x, ifindex=%u, sin=%s",
 	       pfx,
 	       iface->ifnum,
-	       iface->fd,
-	       iface->bfd,
+	       (long long)iface->fd,
+	       (long long)iface->bfd,
 	       iface->name,
 	       iface->flags,
 	       iface->ifindex,
@@ -2561,7 +2565,7 @@
 {
 #ifdef OPEN_BCAST_SOCKET
 	struct interface *	interf;
-	int			nif;
+	unsigned int		nif;
 
 	nif = 0;
 	set_reuseaddr(1);
@@ -2638,11 +2642,10 @@
 		}
 	}
 	set_reuseaddr(0);
-	if (nif > 0) {
+	if (nif != 0) {
 		broadcast_client_enabled = ISC_TRUE;
 		DPRINTF(1, ("io_setbclient: listening to %d broadcast addresses\n", nif));
-	}
-	else if (!nif) {
+	} else {
 		broadcast_client_enabled = ISC_FALSE;
 		msyslog(LOG_ERR,
 			"Unable to listen for broadcasts, no broadcast interfaces available");
Index: contrib/ntp/ntpd/ntp_peer.c
===================================================================
--- contrib/ntp/ntpd/ntp_peer.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_peer.c	(版本 316722)
@@ -161,7 +161,7 @@
 	int i;
 	struct peer *peers;
 
-	peers = emalloc_zero(INC_PEER_ALLOC * sizeof(*peers));
+	peers = eallocarray(INC_PEER_ALLOC, sizeof(*peers));
 
 	for (i = INC_PEER_ALLOC - 1; i >= 0; i--)
 		LINK_SLIST(peer_free, &peers[i], p_link);
@@ -309,7 +309,8 @@
 	for (p = peer_hash[hash]; p != NULL; p = p->adr_link) {
 
 		/* [Bug 3072] ensure interface of peer matches */
-		if (p->dstadr != rbufp->dstadr)
+		/* [Bug 3356] ... if NOT a broadcast peer!     */
+		if (p->hmode != MODE_BCLIENT && p->dstadr != rbufp->dstadr)
 			continue;
 
 		/* ensure peer source address matches */
